#include "qosmanager.h"

using namespace Coral;

class QMI : public QoSManagerInterface {
  void adaptTransportInfo(int flowIdentifier, Coral::TransportInfo ti)
  {};
};


int main() {
  QoSManager qm;
  QMI qmi;

  ExtendedTransportInfo ti;
  
  ti.SrcDest.Destination.reset();

  ti.StartFramesPerSecond = 1;

  ti.QualityLevel[0].QualityLayers = 1;
  ti.QualityLevel[0].FramesPerSecondScale = 1;
  ti.QualityLevel[0].QualityLayer[0].FrameSize = 100000;
  ti.QualityLevel[0].Quality = 64;
  ti.QualityLevel[0].MaxTransferDelay = 10;
  //ti.QualityLevel[0].LossRate = 10;
  ti.QualityLevel[0].LevelUp = 1;
  ti.QualityLevel[0].LevelDown = 255;


  ti.QualityLevel[1].QualityLayers = 1;
  ti.QualityLevel[1].FramesPerSecondScale = 1;
  ti.QualityLevel[1].QualityLayer[0].FrameSize = 200000;
  ti.QualityLevel[1].Quality = 128;
  ti.QualityLevel[1].MaxTransferDelay = 10;
  //ti.QualityLevel[0].LossRate = 10;
  ti.QualityLevel[1].LevelUp = 2;
  ti.QualityLevel[1].LevelDown = 0  ;

  ti.QualityLevel[2].QualityLayers = 1;
  ti.QualityLevel[2].FramesPerSecondScale = 1;
  ti.QualityLevel[2].QualityLayer[0].FrameSize = 250000;
  ti.QualityLevel[2].Quality = 255;
  ti.QualityLevel[2].MaxTransferDelay = 10;
  //ti.QualityLevel[0].LossRate = 10;
  ti.QualityLevel[2].LevelUp = 255;
  ti.QualityLevel[2].LevelDown = 1  ;
  

  ti.QualityLevels = 3; 

  card32 id1=qm.getID();
  card32 id2=qm.getID();
  card32 id3=qm.getID();
  card32 id4=qm.getID();

  //card32 session1 = qm.newSession();

  //  cout << (int) qm.getSession(session1)->getQoSManager()->getNumPrios() << endl;;

  qm.newStream(id1,ti,&qmi);
  //  qm.newStream(id2,ti,&qmi);
  //  qm.newStream(id3,ti,&qmi);
  //  qm.newStream(id4,ti,&qmi);

  
  //  qm.setFractionLost(id1,0.5);
  //  qm.setFractionLost(id1,0.9);
  //  qm.setFractionLost(id1,0.9);


  while(true) {}

  return 0;
}
