#include "randomizer.h"
#include "strings.h"
#include "socket.h"
#include "internetaddress.h"


// ###### Scan URL ##########################################################
// #### Version 1.00  --  June 22, 2000                                  ####
              String&       protocol,
              String&       host,
              String&       path)
{
   String url = location;

   // ====== Get protocol ===================================================
   integer p1 = url.find("://");
   if(p1 < 0) {
      if(protocol.isNull()) {
         return(false);
      }
      p1 = 0;
   }
   else {
      protocol = url.left(p1);
      p1 += 3;
   }

   // ====== Get host =======================================================
   url = url.mid(p1);
   integer p2 = url.index('/');
   if(p2 < 0) {
      return(false);
   }
   host = url.left(p2);
   
   // ====== Get path =======================================================
   path = url.mid(p2 + 1);
   return(true);
}

void test(const char* url)
{
   String u(url);
   String a1="rtpa",a2,a3;
   if(scanURL2(u,a1,a2,a3)) {
      cout << u << " => A=" << a1 << "  B=" << a2 << "  C=" << a3 << endl;
      RTPAudio::InternetAddress ia(a2);
      cout << "   Address = " << ia << endl;
   }
   else {
      cout << u << "   *** ERROR ***" << endl;
   }
}


void main()
{
//   String url = "rtpa://3ffe:4711::0:7500/../AudioFiles/Test1.list";
   /*
   String url = "rtpa://odin/Test1.list";
   String a1 = "rtpa",a2,a3;
   scanURL2(url,a1,a2,a3);

   cout << "A = " << a1 << endl;
   cout << "B = " << a2 << endl;
   cout << "C = " << a3 << endl;
   */
   test("rtpa://odin/Test1.list");
   test("rtpa://odin:7500/Test1.list");
   test("rtpa://3ffe:4711::0:7500/Test1.list");
   test("rtpa://1.2.3.4/Test1.list");
   test("rtpa://1.2.3.4:1234/Test1.list");
   test("rtpa://::1/Test1.list");


   /*
   test("odin/Test1.list");
   test("odin:7500/Test1.list");
   test("3ffe:4711::0:7500/Test1.list");
   test("1.2.3.4/Test1.list");
   test("1.2.3.4:1234/Test1.list");
   test("::1/Test1.list");

   test("xaddad:2234///");
   */
}

