#ifndef TRANSPORTINFO
#define TRANSPORTINFO

class TransportInfo {
 public:
  //TransportInfo();
  long  WantedBytesPerSecond;
  int   WantedFramesPerSecond;
  int   WantedPacketsPerSecond;
  const static short MaxQualityLevels = 16;
  short QualityLevels;

  struct QualityLevelTransportInfo {  
    long BytesPerSecond;
    int  FramesPerSecond;
    int  PacketsPerSecond;

    // added:
    short Quality;
    short LossRate;
   
   };

  QualityLevelTransportInfo CurrentSetting;
  QualityLevelTransportInfo QualityLevel[MaxQualityLevels];

  // added
  bool layerdEncoding;

};

#endif
