#include"resvmod.h"
#include"stdio.h"
//#include"../trafficclassvalues.h"


RESV_Modul::RESV_Modul()
{
	
	// Eingabe aus der Datei
	FILE *input;
	ClassBandwidthMap = new ClassBandwidthMapType();
	/* read input file */
        if( (input = fopen("SLA.config", "r")) == NULL )
	{
		fprintf(stderr, "ERROR: RESV_Modul::RESV_Modul() - Cannot open file SLA.config!\n");
		exit(1);
	}

/* TD: Gesamtbandbreite wird jetzt durch Aufsummieren berechnet.
	
	// Fuellen von class-bandbreite Map 
	// das kann man durch stl ersetzen

	if( fscanf(input, "%*s%d", &(ClassBandwidthMap->wholeBandwidth) )!= 1 )
	{
		fprintf(stderr, "error while scanning file \n");
	        exit(1);
	}
	// printf(" Bandbreite = %d\n",ClassBandwidthMap->wholeBandwidth);
*/
	
	ClassBandwidthMap->wholeBandwidth = 0;
	for(int i = 0; i < 16; i++ )
	{
		if( fscanf(input,"%*s%d",&ClassBandwidthMap->prio[i] ) != 1)
		{
			fprintf(stderr, "error while scanning file \n");
		        exit(1);
		}
 		// printf("Bandbreite%d=%d\n",i,ClassBandwidthMap->prio[i]);
 		
 		ClassBandwidthMap->wholeBandwidth += ClassBandwidthMap->prio[i];
  	}  	
  	// printf(" Bandbreite = %d\n",ClassBandwidthMap->wholeBandwidth);
	fclose(input);
  

	// Fuellen von priority
	tos = new int[16];
	tos[0]= 46;
	tos[1]= 10;
	tos[2]= 12;
	tos[3]= 14;
	tos[4]= 18;
	tos[5]= 20;
	tos[6]= 22;
	tos[7]= 26;
	tos[8]= 28;
	tos[9]= 30;
	tos[10]= 34;
	tos[11]= 36;
	tos[12]= 38;
	tos[13]= 0;
	tos[14]= 0;
	tos[15]= 0;
	using namespace Coral;

	//	TrafficClassValues*		tc_val;
	//	tc_val = new TrafficClassValues();
	//	for(int i = 0 ; i < 16 ; i++ )
	//	{
	//	   tos[i] = tc_val->TCValues[i];
	//	}
	
}


RESV_Modul::~RESV_Modul()
{
	delete ClassBandwidthMap;
	delete tos;
	//delete tc_val;
}


void RESV_Modul::Get_BandwidthInfo(ClassBandwidthMapType* elem)
{
	for(int i = 0; i < 16; i++)
	   elem->prio[i]= ClassBandwidthMap->prio[i];
	elem->wholeBandwidth = ClassBandwidthMap->wholeBandwidth ;
}


void RESV_Modul::Get_Priority(Coral::ExtendedTransportInfo* tielem, int* priorities, int size)
{
  int i=0;
  for(i=0; i < size; i++) {
    tielem->SrcDest[i].TrafficClass = (card8)tos[priorities[i]];
  }
}


card8 RESV_Modul::Get_Priority(card8 priorityClass)
{
  return (card8) tos[priorityClass];
}
